/* Copyright (c) 2005 MichalDominik@gmail.com ; MIT X11 license
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT
 * SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */
 
#include <glib-2.0/glib.h>


gpointer CounterThreadStart (gpointer data)
{
        g_print ("UNMANAGED: Thread starting it's function\n");
        gboolean (*DelegateFunc) (guint32 value) = data;

        guint32 i = 0;
        while (1) {
                g_idle_add ((gpointer) DelegateFunc,&i);
                g_usleep (G_USEC_PER_SEC);
                i++;
        }

}


void SpawnCounterThread (void (*CounterCallback) (guint32 val))
{
        g_print ("UNMANAGED: Spawning a thread with the passed delegate\n");
        g_thread_create (CounterThreadStart, (gpointer) CounterCallback, FALSE, NULL);
}
